"use strict";exports.__esModule=true;exports.collectPages=collectPages;exports.printTreeView=printTreeView;exports.getPageSizeInKb=getPageSizeInKb;exports.isPageStatic=isPageStatic;exports.hasCustomAppGetInitialProps=hasCustomAppGetInitialProps;var _chalk=_interopRequireDefault(require("chalk"));var _fs=_interopRequireDefault(require("fs"));var _textTable=_interopRequireDefault(require("next/dist/compiled/text-table"));var _path=_interopRequireDefault(require("path"));var _stripAnsi=_interopRequireDefault(require("strip-ansi"));var _util=require("util");var _reactIs=require("react-is");var _prettyBytes=_interopRequireDefault(require("../lib/pretty-bytes"));var _recursiveReaddir=require("../lib/recursive-readdir");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}const fsStat=(0,_util.promisify)(_fs.default.stat);function collectPages(directory,pageExtensions){return(0,_recursiveReaddir.recursiveReadDir)(directory,new RegExp(`\\.(?:${pageExtensions.join('|')})$`));}function printTreeView(list,pageInfos,serverless){const getPrettySize=_size=>{const size=(0,_prettyBytes.default)(_size);// green for 0-100kb
if(_size<100*1000)return _chalk.default.green(size);// yellow for 100-250kb
if(_size<250*1000)return _chalk.default.yellow(size);// red for >= 250kb
return _chalk.default.red.bold(size);};const messages=[['Page','Size','Files','Packages'].map(entry=>_chalk.default.underline(entry))];list.sort((a,b)=>a.localeCompare(b)).forEach((item,i)=>{const symbol=i===0?list.length===1?'─':'┌':i===list.length-1?'└':'├';const pageInfo=pageInfos.get(item);messages.push([`${symbol} ${item.startsWith('/_')?' ':pageInfo&&pageInfo.static?_chalk.default.bold('⚡'):serverless?'λ':'σ'} ${item}`,...(pageInfo?[pageInfo.isAmp?_chalk.default.cyan('AMP'):pageInfo.size>=0?getPrettySize(pageInfo.size):'',pageInfo.chunks?pageInfo.chunks.internal.size.toString():'',pageInfo.chunks?pageInfo.chunks.external.size.toString():'']:['','',''])]);});console.log((0,_textTable.default)(messages,{align:['l','l','r','r'],stringLength:str=>(0,_stripAnsi.default)(str).length}));console.log();console.log((0,_textTable.default)([serverless?['λ','(Lambda)',`page was emitted as a lambda (i.e. ${_chalk.default.cyan('getInitialProps')})`]:['σ','(Server)',`page will be server rendered (i.e. ${_chalk.default.cyan('getInitialProps')})`],[_chalk.default.bold('⚡'),'(Static File)','page was prerendered as static HTML']],{align:['l','l','l'],stringLength:str=>(0,_stripAnsi.default)(str).length}));console.log();}async function getPageSizeInKb(page,distPath,buildId){const clientBundle=_path.default.join(distPath,`static/${buildId}/pages/`,`${page}.js`);try{return(await fsStat(clientBundle)).size;}catch(_){}return-1;}function isPageStatic(serverBundle,runtimeEnvConfig){try{require('../next-server/lib/runtime-config').setConfig(runtimeEnvConfig);const mod=require(serverBundle);const Comp=mod.default||mod;if(!Comp||!(0,_reactIs.isValidElementType)(Comp)||typeof Comp==='string'){throw new Error('INVALID_DEFAULT_EXPORT');}const config=mod.config||{};return{static:typeof Comp.getInitialProps!=='function',prerender:config.experimentalPrerender===true,isHybridAmp:config.amp==='hybrid'};}catch(err){if(err.code==='MODULE_NOT_FOUND')return{};throw err;}}function hasCustomAppGetInitialProps(_appBundle,runtimeEnvConfig){require('../next-server/lib/runtime-config').setConfig(runtimeEnvConfig);let mod=require(_appBundle);if(_appBundle.endsWith('_app.js')){mod=mod.default||mod;}else{// since we don't output _app in serverless mode get it from a page
mod=mod._app;}return mod.getInitialProps!==mod.origGetInitialProps;}